#include <cstdio>
#include <cstdlib>

#include "db.hh"

using namespace std;

db::db() : status(0)
{
}

db::db(const string &host,
	   const string &user,
	   const string &pass)
{
	status = 0;
    connect(host, user, pass);
}
	
void db::connect(const string &host,
	             const string &user,
	             const string &pass)
{
    sql.connect("", host.c_str(), user.c_str(), pass.c_str());
}

db::~db()
{
}

db::result db::query(const string &s)
{
	MysqlQuery r = con.query();
	r << s;	
	return result(r.store());
}

db::result::result(MysqlResult r) : res(r), isok(false)
{
	i = r.begin();
	if(i != r.end())
	{
		isok = true;
		*this = *i;
	}
}

bool db::result::movenext()
{
	if(!res)return (isok = false);
	
	row = mysql_fetch_row(res);
	if(row)
	{
		lens = mysql_fetch_lengths(res);
		isok = true;
		genmap();
	}
	else
		isok = false;
	return isok;
}

int usertype::find(const string &mail)
{
	db::result res(database.query("select * from users where email='" + mail + "'"));
	if(!res.ok())return -1;
	
	email = res["email"];
	passwd= res["passwd"];
	
	return 0;
}

int cidtype::find(const string &c)
{
	db::result res(database.query("select * from cids where cid='" + c + "'"));
	if(!res.ok())return -1;
	
	cid      = res["cid"];
	email    = res["email"];
	belltype = atoi(res["belltype"].c_str());
	bell     = res["bell"];
		
	return 0;
}

static string stringize(unsigned n)
{
	char Buf[64];
	sprintf(Buf, "%u", n);
	return Buf;
}

static string escaped(const string &s)
{
	string t;
	
	unsigned a, b=s.size();
	
	for(a=0; a<b; ++a)
	{
		if(s[a] == '\0') t += "\\0";
		else if(s[a] == '\'') t += "\\'";
		else if(s[a] == '\\') t += "\\\\";
		else if(s[a] == '"')  t += "\\\"";
		else t += s[a];
	}	
	
	return t;
}

int message::insert()
{
//	cerr << "senttime(3) = " << senttime << endl;
	
	string SQL = 
		"insert into messages (email,cid,msn,recordtime,perishtime,senttime,"
		                     "pathname,bytelength,timelength,compressiontype,"
		                     "mimetype,voicedata,numberdata) "
		           "values('"+email+"','"+cid+
		                "','"+msn+"',"+stringize(recordtime)+","+stringize(perishtime)
		                          +","+stringize(senttime)+",'"+pathname+
		                          "',"+stringize(bytelength)+","+stringize(timelength)
		                         +",'"+compressiontype+"','"+mimetype
		                        +"','"+escaped(voicedata)+"','"+numberdata+"')";
	
	db::result r = database.query(SQL);
	
//	cerr << "hirvitys = \"" << SQL << "\"\n";
	
	return r.res != NULL;
}
