#include <unistd.h>

#include "stream.hh"

#define DLE 0x10

int customstream::sendah(const string &s)
{
	unsigned b=s.size();
	const char *p = s.c_str();	
	while(b)
	{
		int c = std::write(fd, p, b);
		if(c < 0)return -1;
		p += c;
		b -= c; 
	}
	return 0;
}

char customstream::getc()
{
	for(;;)
	{
		if(getcptr < getclen)return getcbuf[getcptr++];
		getclen = read(fd, getcbuf, sizeof getcbuf);
		getcptr = 0;
		if(getclen <= 0)return -1;
	}
}

string &customstream::getline(string &s)
{
	s = "";
	char c;
	for(;;)
	{
		c = getc();
		if(c == '\r' || c == '\n')break;
		if(c == DLE)
			getc();
		else
			s += c;
	}
	return s;
}

void customstream::close()
{
	if(fd >= 0)
	{
		std::close(fd);
		fd = -1;
	}    	
}
